# build some nested data structures for testing purposes

from XMarshaL2 import *

# @dumpable
class RootObject(object):
    counter = 3

    def __init__(self):
        self.sub = SubObject()
        self.data = dict(xyz=4711)
        self.objlist = [ 1, 2, SubObject(), DetailObject() ]

# @dumpable
class SubObject(object):

    def __init__(self): 
        self.values = (3.12, 4711, 8.15)
        self.z = "uwe"
        self.detail = DetailObject()

markAttributesDumpable(SubObject, 'values', 'detail')

# @dumpable
class DetailObject(object):
    statement = "1 < 2 is true"
    blablaliste = ["a", "b", "c"]
    grumpf = {'a' : 13, 42: (1, 2)}

markClassDumpable(RootObject, SubObject, DetailObject)

obj = RootObject()

s = dumps(obj)
print s
o = loads(s)
print o
