
from XMarshaL import dumps, loads

class foo:
    counter = [0]
    def __init__(self, a):
        self.a = a
        self.num = self.counter[0]
        self.counter[0] += 1

def test0():
    y = foo(None)
    for i in range(10):
        y = foo(y)
    s = dumps(y)
    print s
    print loads(s)

def test1():
    from Scientific.Geometry.VectorModule import Vector
    x = [Vector(1.0*a, a*a, 2.0-3.0*a) for a in range(10)]
    y = loads(dumps(x))
    print x
    print y


def speedtest():
    import time
    l = tuple(range(100000))
    
    s = time.clock()
    x = dumps(l)
    y = loads(x)
    print 'XMarshaL : % 8g s, % 8d bytes' % (time.clock() - s, len(x))

    import marshal
    s = time.clock()
    x = marshal.dumps(l)
    y = marshal.loads(x)
    print 'marshal  : % 8g s, % 8d bytes' % (time.clock() - s, len(x))
    
    import cPickle
    s = time.clock()
    x = cPickle.dumps(l)
    y = cPickle.loads(x)
    print 'cPickle  : % 8g s, % 8d bytes' % (time.clock() - s, len(x))
    
    import pickle
    s = time.clock()
    x = pickle.dumps(l)
    y = pickle.loads(x)
    print 'pickle   : % 8g s, % 8d bytes' % (time.clock() - s, len(x))
    
    
    try:
        import json
        s = time.clock()
        x = json.dumps(l)
        y = json.loads(x)
        print 'json     : % 8g s, % 8d bytes' % (time.clock() - s, len(x))
    except:
        pass

    try:
        import XMarshaL2
        s = time.clock()
        x = XMarshaL2.dumps(l)
        y = XMarshaL2.loads(x)
        print 'XMarshaL2: % 8g s, % 8d bytes' % (time.clock() - s, len(x))
    except:
        pass


test0()
try:
    test1()
except:
    pass
speedtest()
        
